tests.sh: use variable isinterpret instead of hard-coded checks
[nit.git] / tests / tests.sh
1 #!/bin/bash
2 # This file is part of NIT ( http://www.nitlanguage.org ).
3 #
4 # Copyright 2004-2008 Jean Privat <jean@pryen.org>
5 #
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not use this file except in compliance with the License.
8 # You may obtain a copy of the License at
9 #
10 # http://www.apache.org/licenses/LICENSE-2.0
11 #
12 # Unless required by applicable law or agreed to in writing, software
13 # distributed under the License is distributed on an "AS IS" BASIS,
14 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15 # See the License for the specific language governing permissions and
16 # limitations under the License.
17
18 # This shell script compile, run and verify Nit program files
19
20 # Set lang do default to avoid failed tests because of locale
21 export LANG=C
22 export LC_ALL=C
23 export NIT_TESTING=true
24 export MNIT_SRAND=0
25
26 unset NIT_DIR
27
28 # Get the first Java lib available
29 shopt -s nullglob
30 paths=`echo /usr/lib/jvm/*/`
31 paths=($paths)
32 JAVA_HOME=${paths[0]}
33
34 paths=`echo $JAVA_HOME/jre/lib/*/{client,server}/`
35 paths=($paths)
36 JNI_LIB_PATH=${paths[0]}
37 shopt -u nullglob
38
39 usage()
40 {
41 e=`basename "$0"`
42 cat<<END
43 Usage: $e [options] modulenames
44 -o option Pass option to the engine
45 -v Verbose (show tests steps)
46 -h This help
47 --engine Use a specific engine (default=nitg)
48 --noskip Do not skip a test even if the .skip file matches
49 END
50 }
51
52 # $1 is the pattern of the test
53 # $2 is the file to compare to
54 # the result is:
55 # 0: if the file to compare to do not exists
56 # 1: if the file match
57 # 2: if the file match with soso
58 # 3: if the file do not match
59 function compare_to_result()
60 {
61 local pattern="$1"
62 local sav="$2"
63 if [ ! -r "$sav" ]; then return 0; fi
64 test "`cat "$sav"`" = "UNDEFINED" && return 1
65 diff -u "$sav" "out/$pattern.res" > "out/$pattern.diff.sav.log"
66 if [ "$?" == 0 ]; then
67 return 1
68 fi
69 sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
70 sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.sav2"
71 grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
72 grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
73 diff -u "out/$pattern.sav2" "out/$pattern.res2" > "out/$pattern.diff.sav.log2"
74 if [ "$?" == 0 ]; then
75 return 2
76 else
77 return 3
78 fi
79 }
80
81 # As argument: the pattern used for the file
82 function process_result()
83 {
84 # Result
85 pattern=$1
86 description=$2
87 pack=$3
88 SAV=""
89 NSAV=""
90 FIXME=""
91 NFIXME=""
92 SOSO=""
93 NSOSO=""
94 SOSOF=""
95 NSOSOF=""
96 OLD=""
97 LIST=""
98 FIRST=""
99 echo >>$xml "<testcase classname='$pack' name='$description'>"
100 #for sav in "sav/$engine/fixme/$pattern.res" "sav/$engine/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
101 for savdir in $savdirs; do
102 sav=$savdir/fixme/$pattern.res
103 compare_to_result "$pattern" "$sav"
104 case "$?" in
105 0)
106 ;; # no file
107 1)
108 OLD="$LIST"
109 FIXME="$sav"
110 LIST="$LIST $sav"
111 ;;
112 2)
113 if [ -z "$FIRST" ]; then
114 SOSOF="$sav"
115 FIRST="$sav"
116 fi
117 LIST="$LIST $sav"
118 ;;
119 3)
120 if [ -z "$FIRST" ]; then
121 NFIXME="$sav"
122 FIRST="$sav"
123 fi
124 LIST="$LIST $sav"
125 ;;
126 esac
127
128 sav=$savdir/$pattern.res
129 compare_to_result "$pattern" "$sav"
130 case "$?" in
131 0)
132 ;; # no file
133 1)
134 OLD="$LIST"
135 SAV="$sav"
136 LIST="$LIST $sav"
137 ;;
138 2)
139 if [ -z "$FIRST" ]; then
140 SOSO="$sav"
141 FIRST="$sav"
142 fi
143 LIST="$LIST $sav"
144 ;;
145 3)
146 if [ -z "$FIRST" ]; then
147 NSAV="$sav"
148 FIRST="$sav"
149 fi
150 LIST="$LIST $sav"
151 ;;
152 esac
153 done
154 OLD=`echo "$OLD" | sed -e 's/ */ /g' -e 's/^ //' -e 's/ $//'`
155 grep 'NOT YET IMPLEMENTED' "out/$pattern.res" >/dev/null
156 NYI="$?"
157 if [ -n "$SAV" ]; then
158 if [ -n "$OLD" ]; then
159 echo "[*ok*] out/$pattern.res $SAV - but $OLD remains!"
160 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
161 remains="$remains $OLD"
162 else
163 echo "[ok] out/$pattern.res $SAV"
164 fi
165 ok="$ok $pattern"
166 elif [ -n "$FIXME" ]; then
167 if [ -n "$OLD" ]; then
168 echo "[*fixme*] out/$pattern.res $FIXME - but $OLD remains!"
169 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
170 remains="$remains $OLD"
171 else
172 echo "[fixme] out/$pattern.res $FIXME"
173 echo >>$xml "<skipped/>"
174 fi
175 todos="$todos $pattern"
176 elif [ "x$NYI" = "x0" ]; then
177 echo "[todo] out/$pattern.res -> not yet implemented"
178 echo >>$xml "<skipped/>"
179 todos="$todos $pattern"
180 elif [ -n "$SOSO" ]; then
181 echo "[======= soso out/$pattern.res $SOSO =======]"
182 echo >>$xml "<error message='soso out/$pattern.res $SOSO'/>"
183 echo >>$xml "<system-out><![CDATA["
184 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
185 echo >>$xml "]]></system-out>"
186 nok="$nok $pattern"
187 echo "$ii" >> "$ERRLIST"
188 elif [ -n "$SOSOF" ]; then
189 echo "[======= fixme soso out/$pattern.res $SOSOF =======]"
190 echo >>$xml "<error message='soso out/$pattern.res $SOSO'/>"
191 echo >>$xml "<system-out><![CDATA["
192 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
193 echo >>$xml "]]></system-out>"
194 nok="$nok $pattern"
195 echo "$ii" >> "$ERRLIST"
196 elif [ -n "$NSAV" ]; then
197 echo "[======= fail out/$pattern.res $NSAV =======]"
198 echo >>$xml "<error message='fail out/$pattern.res $NSAV'/>"
199 echo >>$xml "<system-out><![CDATA["
200 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
201 echo >>$xml "]]></system-out>"
202 nok="$nok $pattern"
203 echo "$ii" >> "$ERRLIST"
204 elif [ -n "$NFIXME" ]; then
205 echo "[======= changed out/$pattern.res $NFIXME ======]"
206 echo >>$xml "<error message='changed out/$pattern.res $NFIXME'/>"
207 echo >>$xml "<system-out><![CDATA["
208 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
209 echo >>$xml "]]></system-out>"
210 nok="$nok $pattern"
211 echo "$ii" >> "$ERRLIST"
212 elif [ -s out/$pattern.res ]; then
213 echo "[=== no sav ===] out/$pattern.res is not empty"
214 echo >>$xml "<error message='no sav and not empty'/>"
215 echo >>$xml "<system-out><![CDATA["
216 cat -v >>$xml out/$pattern.res
217 echo >>$xml "]]></system-out>"
218 nos="$nos $pattern"
219 else
220 # no sav but empty res
221 echo "[0k] out/$pattern.res is empty"
222 ok="$ok $pattern"
223 fi
224 if test -s out/$pattern.cmp.err; then
225 echo >>$xml "<system-err><![CDATA["
226 cat -v >>$xml out/$pattern.cmp.err
227 echo >>$xml "]]></system-err>"
228 fi
229 echo >>$xml "</testcase>"
230 }
231
232 need_skip()
233 {
234 test "$noskip" = true && return 1
235 if echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
236 echo "=> $2: [skip]"
237 echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
238 return 0
239 fi
240 if test -n "$isinterpret" && echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
241 echo "=> $2: [skip exec]"
242 echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
243 return 0
244 fi
245 return 1
246 }
247
248 skip_exec()
249 {
250 test "$noskip" = true && return 1
251 if echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
252 echo -n "_ "
253 return 0
254 fi
255 return 1
256 }
257
258 skip_cc()
259 {
260 test "$noskip" = true && return 1
261 if echo "$1" | grep -f "cc.skip" >/dev/null 2>&1; then
262 return 0
263 fi
264 return 1
265 }
266
267 find_nitc()
268 {
269 name="$enginebinname"
270 recent=`ls -t ../src/$name ../src/$name_[0-9] ../bin/$name ../c_src/$name 2>/dev/null | head -1`
271 if [[ "x$recent" == "x" ]]; then
272 echo "Could not find binary for engine $engine, aborting"
273 exit 1
274 fi
275 echo "Find binary for engine $engine: $recent $OPT"
276 NITC=$recent
277 }
278
279 verbose=false
280 stop=false
281 engine=nitg
282 noskip=
283 savdirs=
284 while [ $stop = false ]; do
285 case $1 in
286 -o) OPT="$OPT $2"; shift; shift;;
287 -v) verbose=true; shift;;
288 -h) usage; exit;;
289 --engine) engine="$2"; shift; shift;;
290 --noskip) noskip=true; shift;;
291 *) stop=true
292 esac
293 done
294 enginebinname=$engine
295 isinterpret=
296 case $engine in
297 nitg)
298 engine=nitg-s;
299 enginebinname=nitg;
300 OPT="--separate $OPT"
301 ;;
302 nitg-s)
303 enginebinname=nitg;
304 OPT="--separate $OPT"
305 ;;
306 nitg-e)
307 enginebinname=nitg;
308 OPT="--erasure $OPT"
309 ;;
310 nitg-sg)
311 enginebinname=nitg;
312 OPT="--semi-global $OPT"
313 ;;
314 nitg-g)
315 enginebinname=nitg;
316 OPT="--global $OPT"
317 ;;
318 nit)
319 engine=niti
320 isinterpret=true
321 ;;
322 niti)
323 enginebinname=nit
324 isinterpret=true
325 ;;
326 ;;
327 emscripten)
328 enginebinname=nitg
329 OPT="-m emscripten_nodejs.nit --semi-global $OPT"
330 savdirs="sav/nitg-sg/"
331 ;;
332 nitc)
333 echo "disabled engine $engine"
334 exit 0
335 ;;
336 *)
337 echo "unknown engine $engine"
338 exit 1
339 ;;
340 esac
341
342 savdirs="sav/$engine $savdirs sav/"
343
344 # The default nitc compiler
345 [ -z "$NITC" ] && find_nitc
346
347 # Set NIT_DIR if needed
348 [ -z "$NIT_DIR" ] && export NIT_DIR=..
349
350 if sh -c "timelimit echo" 1>/dev/null 2>&1; then
351 TIMEOUT="timelimit -t 600"
352 elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
353 TIMEOUT="timeout 600s"
354 else
355 echo "No timelimit or timeout command detected. Tests may hang :("
356 fi
357
358 # Mark to distinguish files among tests
359 # MARK=
360
361 # File where error tests are outputed
362 # Old ERRLIST is backuped
363 ERRLIST=${ERRLIST:-errlist}
364 ERRLIST_TARGET=$ERRLIST
365
366 if [ $# = 0 ]; then
367 usage;
368 exit
369 fi
370
371 # Initiate new ERRLIST
372 if [ "x$ERRLIST" = "x" ]; then
373 ERRLIST=/dev=null
374 else
375 ERRLIST=$ERRLIST.tmp
376 > "$ERRLIST"
377 fi
378
379 ok=""
380 nok=""
381 todos=""
382 xml="tests-$engine.xml"
383 echo >$xml "<testsuites><testsuite>"
384
385 # CLEAN the out directory
386 rm -rf out/ 2>/dev/null
387 mkdir out 2>/dev/null
388
389 for ii in "$@"; do
390 if [ ! -f $ii ]; then
391 echo "File '$ii' does not exist."
392 continue
393 fi
394 f=`basename "$ii" .nit`
395
396 pack=`echo $ii | perl -p -e 's|^../([^/]*)/([a-zA-Z_]*).*|\1.\2| || s|^([a-zA-Z]*)[^_]*_([a-zA-Z]*).*|\1.\2| || s|\W*([a-zA-Z_]*).*|\1|'`
397
398 # Sould we skip the file for this engine?
399 need_skip $f $f $pack && continue
400
401 tmp=${ii/../AA}
402 if [ "x$tmp" = "x$ii" ]; then
403 includes="-I . -I ../lib/standard -I ../lib/standard/collection -I alt"
404 else
405 includes="-I alt"
406 fi
407
408 for i in "$ii" `./alterner.pl --start '#' --altsep '_' $ii`; do
409 bf=`basename $i .nit`
410 ff="out/$bf"
411
412 # Sould we skip the alternative for this engine?
413 need_skip $bf $bf $pack && continue
414
415 echo -n "=> $bf: "
416
417 if [ -f "$f.inputs" ]; then
418 inputs="$f.inputs"
419 export MNIT_READ_INPUT="$f.inputs"
420 else
421 inputs=/dev/null
422 export MNIT_READ_INPUT=/dev/null
423 fi
424
425 ffout="$ff.bin"
426 if [ "$engine" = "emscripten" ]; then
427 ffout="$ff.bin.js"
428 fi
429
430 if [ -n "$isinterpret" ]; then
431 cat > "./$ff.bin" <<END
432 exec $NITC --no-color $OPT "$i" $includes -- "\$@"
433 END
434 chmod +x "./$ff.bin"
435 > "$ff.cmp.err"
436 > "$ff.compile.log"
437 ERR=0
438 else
439 if skip_cc "$bf"; then
440 nocc="--no-cc"
441 else
442 nocc=
443 fi
444 # Compile
445 if [ "x$verbose" = "xtrue" ]; then
446 echo ""
447 echo $NITC --no-color $OPT -o "$ffout" "$i" "$includes" $nocc
448 fi
449 NIT_NO_STACK=1 JNI_LIB_PATH=$JNI_LIB_PATH JAVA_HOME=$JAVA_HOME \
450 $TIMEOUT $NITC --no-color $OPT -o "$ffout" "$i" $includes $nocc 2> "$ff.cmp.err" > "$ff.compile.log"
451 ERR=$?
452 if [ "x$verbose" = "xtrue" ]; then
453 cat "$ff.compile.log"
454 cat >&2 "$ff.cmp.err"
455 fi
456 fi
457 if [ "$engine" = "emscripten" ]; then
458 echo > "./$ff.bin" "nodejs $ffout \"\$@\""
459 chmod +x "$ff.bin"
460 if grep "Fatal Error: more than one primitive class" "$ff.compile.log" > /dev/null; then
461 echo " [skip] do no not imports kernel"
462 echo >>$xml "<testcase classname='$pack' name='$bf'><skipped/></testcase>"
463 continue
464 fi
465 fi
466 if [ "$ERR" != 0 ]; then
467 echo -n "! "
468 cat "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
469 process_result $bf $bf $pack
470 elif [ -n "$nocc" ]; then
471 # not compiled
472 echo -n "nocc "
473 > "$ff.res"
474 process_result $bf $bf $pack
475 elif [ -x "./$ff.bin" ]; then
476 if skip_exec "$bf"; then
477 # No exec
478 > "$ff.res"
479 process_result $bf $bf $pack
480 break
481 fi
482 echo -n ". "
483 # Execute
484 args=""
485 if [ "x$verbose" = "xtrue" ]; then
486 echo ""
487 echo "NIT_NO_STACK=1 ./$ff.bin" $args
488 fi
489 NIT_NO_STACK=1 LD_LIBRARY_PATH=$JNI_LIB_PATH \
490 $TIMEOUT "./$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
491 if [ "x$verbose" = "xtrue" ]; then
492 cat "$ff.res"
493 cat >&2 "$ff.err"
494 fi
495 if [ -f "$ff.write" ]; then
496 cat "$ff.write" >> "$ff.res"
497 elif [ -d "$ff.write" ]; then
498 LANG=C /bin/ls -F $ff.write >> "$ff.res"
499 fi
500 cp "$ff.res" "$ff.res2"
501 cat "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
502 process_result $bf $bf $pack
503
504 if [ -f "$f.args" ]; then
505 fargs=$f.args
506 cptr=0
507 while read line; do
508 ((cptr=cptr+1))
509 args="$line"
510 bff=$bf"_args"$cptr
511 fff=$ff"_args"$cptr
512 name="$bf args $cptr"
513
514 # Sould we skip the input for this engine?
515 need_skip $bff " $name" $pack && continue
516
517 # use a specific inputs file, if required
518 if [ -f "$bff.inputs" ]; then
519 ffinputs="$bff.inputs"
520 else
521 ffinputs=$inputs
522 fi
523
524 rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
525 if [ "x$verbose" = "xtrue" ]; then
526 echo ""
527 echo "NIT_NO_STACK=1 ./$ff.bin" $args
528 fi
529 echo -n "==> $name "
530 echo "./$ff.bin $args" > "./$fff.bin"
531 chmod +x "./$fff.bin"
532 WRITE="$fff.write" sh -c "NIT_NO_STACK=1 $TIMEOUT ./$fff.bin < $ffinputs > $fff.res 2>$fff.err"
533 if [ "x$verbose" = "xtrue" ]; then
534 cat "$fff.res"
535 cat >&2 "$fff.err"
536 fi
537 if [ -f "$fff.write" ]; then
538 cat "$fff.write" >> "$fff.res"
539 elif [ -d "$fff.write" ]; then
540 LANG=C /bin/ls -F $fff.write >> "$fff.res"
541 fi
542 if [ -s "$fff.err" ]; then
543 cp "$fff.res" "$fff.res2"
544 cat "$fff.err" "$fff.res2" > "$fff.res"
545 fi
546 process_result $bff " $name" $pack
547 done < $fargs
548 fi
549 elif [ -f "./$ff.bin" ]; then
550 echo "Not executable (platform?)" > "$ff.res"
551 process_result $bf "$bf" $pack
552 else
553 echo -n "! "
554 cat "$ff.cmp.err" > "$ff.res"
555 echo "Compilation error" > "$ff.res"
556 process_result $bf "$bf" $pack
557 fi
558 done
559 done
560
561 echo "engine: $engine ($enginebinname $OPT)"
562 echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos $todos | wc -w`
563
564 if [ -n "$nok" ]; then
565 echo "fail: $nok"
566 echo "There were $(echo $nok | wc -w) errors ! (see file $ERRLIST)"
567 fi
568 if [ -n "$nos" ]; then
569 echo "no sav: $nos"
570 fi
571 if [ -n "$todos" ]; then
572 echo "todo/fixme: $todos"
573 fi
574 if [ -n "$remains" ]; then
575 echo "sav that remains: $remains"
576 fi
577
578 # write $ERRLIST
579 if [ "x$ERRLIST" != "x" ]; then
580 if [ -x "$ERRLIST_TARGET" ]; then
581 mv "$ERRLIST_TARGET" "${ERRLIST_TARGET}.bak"
582 fi
583 mv $ERRLIST $ERRLIST_TARGET
584 fi
585
586 echo >>$xml "</testsuite></testsuites>"
587
588 if [ -n "$nok" ]; then
589 exit 1
590 else
591 exit 0
592 fi